/***************************************************************************
 *   copyright       : (C) 2003-2025 by Pascal Brachet                     *
 *   https://www.xm1math.net/texmaker/                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/


#ifndef LOGHIGHLIGHTER_H
#define LOGHIGHLIGHTER_H

#include <QSyntaxHighlighter>

#include <QHash>
#include <QTextCharFormat>
#include <QColor>

class QTextDocument;

class LogHighlighter : public QSyntaxHighlighter
{
    Q_OBJECT

public:
    LogHighlighter(QTextDocument *parent = 0,QColor standard=QColor("#000000"));
    QColor ColorStandard, ColorFile, ColorError, ColorWarning;
public slots:
void setColors(QList<QColor> colors);
protected:
    void highlightBlock(const QString &text);
};


#endif
